#n_days_of_christmas
# Calculates the total number of presents recieved after N days of Christmas, and plots this on a graph
# LAST UPDATED by Andy French December 2017

#Import Python numeric and plotting libraries
import numpy as Npy
import matplotlib as mpl
mpl.use('Agg')
import matplotlib.pyplot as plt

#

#Display welcome message to console
print(" N days of christmas present calculator")
print(" By Dr Andrew French. December 2017")

#Define fontsize
fsize = 18

#Define maximumnumber of days
Nmax = 31

#Define a vector of days of christmas
n = Npy.arange(1,Nmax+1,1)

#Define x tick marks
num_ticks = 10
tick_spacing = Npy.ceil( Nmax/num_ticks )
xticks = Npy.arange( 1,Nmax, tick_spacing )

#Compute total number of presents recieved after n days
P = (1.0/6)*n*(n+1)*(n+2)

#Create figure and axis
fig = plt.figure(figsize=(10, 8))

#Plot P vs n
plt.plot( n,P,'-',label = r"$y = \frac{1}{6} n(n+1)(n+2)$" , color = [1,0,0] )
plt.xlabel( "Number of days n", size=fsize );
plt.ylabel( "Total number of presents P", size=fsize );
plt.xticks( xticks, fontsize = fsize )
plt.yticks( fontsize = fsize/2 )
plt.title( "Total number of presents "+ r"$P(n)=\frac{1}{6}n(n+1)(n+2)$", size=fsize )
plt.legend( fontsize = fsize,loc = "upper right" )
plt.grid(True)
plt.xlim( 1, Nmax )

#Export PNG file
fig.savefig('Presents.png', dpi=300)

#Wait for user input to close terminal window
input("\n Press return key to close ...")

#End of code
