#Python sine and cosine curve plotter
# LAST UPDATED by Andy French December 2017

#Import Python numeric and plotting libraries
import numpy as Npy
import matplotlib as mpl
mpl.use('Agg')
import matplotlib.pyplot as plt

#

#Display welcome message to console
print(" Python sine and cosine curve plotter")
print(" By Dr Andrew French. December 2017")

#Define fontsize
fsize = 18

#Define number of plot points
N = 1000
    
#Define constant pi
pi = float(Npy.pi);

#Define a linearly spaced vector x
xstart = 0
xend = 4*2*pi
x = Npy.linspace(xstart,xend,N)

#Define x tick marks
xticks = Npy.arange( xstart,Npy.ceil(xend),4 )
yticks = Npy.around( Npy.linspace(-1,1,10), 1 )

#Define sine and cosine of x
y1 = Npy.sin(x)
y2 = Npy.cos(x)

#Create figure and axis
fig = plt.figure(figsize=(10, 8))

#Plot y vs x
plt.plot( x,y1,'-',label = "y = sin(x)" , color = [1,0,0] )
plt.plot( x,y2,'-',label = "y = cos(x)", color = [0,0,1] )
plt.xlabel( "x", size=fsize );
plt.ylabel( "y", size=fsize );
plt.xticks( xticks, fontsize = fsize )
plt.yticks( yticks, fontsize = fsize )
plt.title( "y = sin(x) and y = cos(x)", size=fsize )
plt.legend( fontsize = fsize,loc = "upper right" )
plt.grid(True)
plt.xlim( xstart, xend )

#Export PNG file
fig.savefig('sin(x) & cos(x).png', dpi=300)

#Wait for user input to close terminal window
input("\n Press return key to continue ...")

#End of code
